# This file was auto-generated by Fern from our API Definition.

import typing

import typing_extensions
from ..types.evaluator_arguments_type import EvaluatorArgumentsType
from ..types.human_evaluator_request_return_type import HumanEvaluatorRequestReturnType
from ..types.valence import Valence
from .evaluator_judgment_number_limit import EvaluatorJudgmentNumberLimitParams
from .evaluator_judgment_option_response import EvaluatorJudgmentOptionResponseParams


class HumanEvaluatorRequestParams(typing_extensions.TypedDict):
    arguments_type: EvaluatorArgumentsType
    """
    Whether this Evaluator is target-free or target-required.
    """

    return_type: HumanEvaluatorRequestReturnType
    """
    The type of the return value of the Evaluator.
    """

    attributes: typing_extensions.NotRequired[typing.Dict[str, typing.Optional[typing.Any]]]
    """
    Additional fields to describe the Evaluator. Helpful to separate Evaluator versions from each other with details on how they were created or used.
    """

    options: typing_extensions.NotRequired[typing.Sequence[EvaluatorJudgmentOptionResponseParams]]
    """
    The options that can be applied as judgments.
    """

    number_limits: typing_extensions.NotRequired[EvaluatorJudgmentNumberLimitParams]
    """
    Limits on the judgment that can be applied. Only for Evaluators with `return_type` of 'number'.
    """

    number_valence: typing_extensions.NotRequired[Valence]
    """
    The valence of the number judgment. Only for Evaluators with `return_type` of 'number'. If 'positive', a higher number is better. If 'negative', a lower number is better.
    """

    evaluator_type: typing.Literal["human"]
    instructions: typing_extensions.NotRequired[str]
    """
    Instructions and guidelines for applying judgments.
    """
