# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel


class DirectoryResponse(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    String ID of directory. Starts with `dir_`.
    """

    parent_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    ID of the parent directory. Will be `None` if the directory is the root directory. Starts with `dir_`.
    """

    name: str = pydantic.Field()
    """
    Name of the directory.
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    Description of the directory.
    """

    path: str = pydantic.Field()
    """
    Path to the directory, relative to the root directory. Includes name, e.g. `path/to/directory`.
    """

    readme: typing.Optional[str] = pydantic.Field(default=None)
    """
    Long description of the directory.
    """

    tags: typing.List[str] = pydantic.Field()
    """
    List of tags associated with the directory.
    """

    created_at: dt.datetime
    updated_at: dt.datetime

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
