# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import datetime as dt
import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2, update_forward_refs
from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluation_evaluator_response import EvaluationEvaluatorResponse
from .user_response import UserResponse


class EvaluationResponse(UncheckedBaseModel):
    id: str = pydantic.Field()
    """
    Unique identifier for the Evaluation. Starts with `evr`.
    """

    runs_count: int = pydantic.Field()
    """
    The total number of Runs in the Evaluation.
    """

    evaluators: typing.List[EvaluationEvaluatorResponse] = pydantic.Field()
    """
    The Evaluator Versions used to evaluate.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the Evaluation to help identify it. Must be unique among Evaluations associated with File.
    """

    file_id: typing.Optional[str] = pydantic.Field(default=None)
    """
    Unique identifier for the File associated with the Evaluation.
    """

    created_at: dt.datetime
    created_by: typing.Optional[UserResponse] = None
    updated_at: dt.datetime
    url: typing.Optional[str] = pydantic.Field(default=None)
    """
    URL to view the Evaluation on the Humanloop.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


from .agent_linked_file_response import AgentLinkedFileResponse  # noqa: E402, F401, I001
from .agent_response import AgentResponse  # noqa: E402, F401, I001
from .evaluator_response import EvaluatorResponse  # noqa: E402, F401, I001
from .flow_response import FlowResponse  # noqa: E402, F401, I001
from .monitoring_evaluator_response import MonitoringEvaluatorResponse  # noqa: E402, F401, I001
from .prompt_response import PromptResponse  # noqa: E402, F401, I001
from .tool_response import ToolResponse  # noqa: E402, F401, I001
from .version_deployment_response import VersionDeploymentResponse  # noqa: E402, F401, I001
from .version_id_response import VersionIdResponse  # noqa: E402, F401, I001

update_forward_refs(EvaluationResponse)
