# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel


class ToolFunction(UncheckedBaseModel):
    name: str = pydantic.Field()
    """
    Name for the tool referenced by the model.
    """

    description: str = pydantic.Field()
    """
    Description of the tool referenced by the model
    """

    strict: typing.Optional[bool] = pydantic.Field(default=None)
    """
    If true, forces the model to output json data in the structure of the parameters schema.
    """

    parameters: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = pydantic.Field(default=None)
    """
    Parameters needed to run the Tool, defined in JSON Schema format: https://json-schema.org/
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
